# Copyright Vespa.ai. Licensed under the terms of the Apache 2.0 license. See LICENSE in the project root.

# Disable build id note requirement for now
%undefine _missing_build_ids_terminate_build

# Force special prefix for Vespa
%define _prefix /opt/vespa-deps

# Only strip debug info
%global _find_debuginfo_opts -g

# Don't provide shared library or pkgconfig
%global __provides_exclude ^(lib.*\\.so\\.[0-9.]*\\([A-Za-z._0-9]*\\)\\(64bit\\)|pkgconfig\\(.*)$

# Exclude automated requires for libraries in /opt/vespa-deps/lib64.
%global __requires_exclude ^(lib(crypto|ssl)\\.so\\.[0-9.]*\\([A-Za-z._0-9]*\\)\\(64bit\\)|pkgconfig\\(lib(crypto|ssl)\\))$

# Avoid auto requirement for perl
%global __requires_exclude_from /c_rehash$|\\.pl$

# Version
%define ver_major 3
%define ver_minor 1
%define ver_patch 6
%define ver_release 1

Summary:        OpenSSL package for Vespa
Name:           vespa-openssl
Version:        %{ver_major}.%{ver_minor}.%{ver_patch}
Release:        %{ver_release}%{?dist}
License:        Apache License v2
URL:            https://www.openssl.org
Source0:        https://www.openssl.org/source/openssl-%{version}.tar.gz


%if 0%{?el8}%{?el9}
%define _devtoolset_enable /opt/rh/gcc-toolset-13/enable
BuildRequires: gcc-toolset-13-gcc-c++
BuildRequires: make
BuildRequires: perl
%endif
%if 0%{?fedora}
BuildRequires: gcc-c++
BuildRequires: make
BuildRequires: perl-File-Compare
BuildRequires: perl-File-Copy
BuildRequires: perl-FindBin
%endif

%description
OpenSSL package for Vespa.

%package devel
Summary:        OpenSSL dev package for Vespa.
Requires:       %{name} = %{version}-%{release}

%description devel
OpenSSL dev package for Vespa.

%prep
%setup -q -n openssl-%{version}

%build
%if 0%{?_devtoolset_enable:1}
source %{_devtoolset_enable} || true
%endif
mkdir build && cd build
CFLAGS="-g -O3" \
../config --prefix=%{_prefix} --openssldir=%{_prefix}/conf/ssl --libdir=lib64 -Wl,-rpath=%{_prefix}/lib64 %{?_configure_args}
make %{?_smp_mflags}

%install
%if 0%{?_devtoolset_enable:1}
source %{_devtoolset_enable} || true
%endif
cd build
%make_install

%define _unpackaged_files_terminate_build 0

%files
%{_prefix}/bin/
%{_prefix}/lib64/
%{_prefix}/conf/ssl/
%{_prefix}/share/man/
%license LICENSE.txt

%files devel
%{_prefix}/include/
%{_prefix}/lib64/pkgconfig/
%license LICENSE.txt

%changelog
